program AgilentDSO;

uses
  Forms,
  LibUSB in 'LibUSB.pas',
  HPgrapheMult in 'HPgrapheMult.PAS',
  HPMULT in 'HPMULT.PAS' {MultimetreForm},
  HPDDE in 'HPDDE.PAS' {FormDDE},
  AgilentU in 'AgilentU.pas',
  JMMUTIL in 'JMMUTIL.PAS',
  HPMAIN in 'HPMAIN.PAS' {AgilentFormMain},
  HPABOUT in 'HPABOUT.PAS' {AboutBox},
  HPOSC in 'HPOSC.PAS' {OscilloForm},
  VOIES in 'VOIES.PAS' {VoiesDlg},
  DSO1000OSC in 'DSO1000OSC.PAS' {DSO1000OscilloForm},
  DdeMan in 'DdeMan.pas',
  HelpFormU in 'HelpFormU.pas' {HelpForm},
  fft in 'fft.pas',
  DSOX2000 in 'DSOX2000.PAS' {DSOX2000OscilloForm},
  HPbode in 'HPbode.PAS' {BodeForm},
  AideBodeU in 'AideBodeU.pas' {AideBodeForm},
  OptionsCSV in 'OptionsCSV.pas' {OptionsCSVForm},
  statcalc in 'statcalc.pas',
  Uniteker in 'Uniteker.pas',
  Oneinst in 'Oneinst.pas',
  VisaComLib_TLB in 'VisaComLib_TLB.pas';

// Vcl.Themes,
 // Vcl.Styles;

{$R *.res}

begin
  Application.Initialize;
  Application.MainFormOnTaskbar := True;
  Application.Title := 'Oscilloscope USB Regressi';
  Application.CreateForm(TAgilentFormMain, AgilentFormMain);
  Application.CreateForm(TFormDDE, FormDDE);
  Application.Run;
end.
