unit Hpdde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, registry, clipbrd, ComCtrls, shellApi;

type
  Tenvoi = (eAdd,eLoad,ePlus,eFileLoad);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure ServeurDDEOpen(Sender: TObject);
  private
  public
    procedure Execute(Ordre : Tenvoi;const donnees : TstringList;nomFichier : string);
  end;

var
  FormDDE: TFormDDE;

implementation

uses HPMAIN;

{$R *.DFM}

procedure TFormDDE.Execute(Ordre : Tenvoi;const donnees : TstringList;nomFichier : string);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication),
                   nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(1500);
end;

procedure Lance;
var ordreStr : ansiString;
    OK : boolean;
begin
    case ordre of
         eAdd : OK := ClientDDE.ExecuteMacro('CLIP|ADD', false);
         eLoad : OK := ClientDDE.ExecuteMacro('CLIP|LOAD', false);
         ePlus : OK := ClientDDE.ExecuteMacro('CLIP|PLUS',false);
         eFileLoad : begin
            ordreStr := 'FILE|LOAD('+ansiString(nomFichier)+')';
            OK := ClientDDE.ExecuteMacro(PAnsiChar(ordreStr),false)
         end;
         else OK := true;
    end;
    if not OK then ShowMessage('Transfert non excut');
    ClientDDE.CloseLink;
end;

begin
     LanceRegressi;
     if ordre<>eFileLoad then ClipBoard.asText := Donnees.text;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
       then lance
       else begin
            sleep(2000);
      // OpenLik false efface les paramtres
            ClientDDE.SetLink('Regressi','ServeurDDE');
            ClientItem.DDEItem := 'ServeurItem';
            if ClientDDE.OpenLink
               then lance
               else ShowMessage('Impossible de lancer Regressi');
       end;
end;

procedure TFormDDE.FormDestroy(Sender: TObject);
begin
     ClientDDE.CloseLink
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TregIniFile;
begin
    Ini := TregIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    if ClientDDE.ServiceApplication='' then begin
       Ini := TRegIniFile.create('Software');
       ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
       Ini.Free;
    end;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
end;

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
begin
     if (Msg.Count = 1) then begin
       try
       AgilentFormMain.setFocusMain;
       except
       end;
     end
end;

procedure TFormDDE.ServeurDDEOpen(Sender: TObject);
begin
     AgilentFormMain.setFocusMain;
end;

{
procedure lance(s, params: string);

// V1 by Pat Ritchey, V2 by P.Below
function WinExecAndWait32(CommandLine: string; ShowWindow: Word): DWORD;

  procedure WaitFor(ProcessHandle: THandle);
  var
    msg: TMsg;
    ret: DWORD;
  begin
    repeat
      ret := MsgWaitForMultipleObjects(
               1,            // 1 handle to wait on
               ProcessHandle, // the handle
               False,         // wake on any event
               INFINITE,      // wait without timeout
               QS_PAINT or    // wake on paint messages
               QS_SENDMESSAGE // or messages from other threads
               );
      if ret = WAIT_FAILED then Exit; // can do little here
      if ret = (WAIT_OBJECT_0 + 1) then begin
        // Woke on a message, process paint messages only. Calling
        //  PeekMessage gets messages send from other threads processed.
        while PeekMessage(msg, 0, WM_PAINT, WM_PAINT, PM_REMOVE) do
          DispatchMessage(msg)
      end
    until ret = WAIT_OBJECT_0
  end;

var
  zAppName: array[0..512] of Char;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  StrPCopy(zAppName, CommandLine);
  FillChar(StartupInfo, Sizeof(StartupInfo), #0);
  StartupInfo.cb := Sizeof(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := ShowWindow;
  if not CreateProcess(nil,
    zAppName,            // pointer to command line string
    nil,                  // pointer to process security attributes
    nil,                  // pointer to thread security attributes
    False,                // handle inheritance flag
    CREATE_NEW_CONSOLE or // creation flags
    NORMAL_PRIORITY_CLASS,
    nil,                  // pointer to new environment block
    nil,                  // pointer to current directory name
    StartupInfo,          // pointer to STARTUPINFO
    ProcessInfo)          // pointer to PROCESS_INF
  then
    Result := DWORD(-1)   // failed, GetLastError has error code
  else begin
     WaitFor(ProcessInfo.hProcess);
     GetExitCodeProcess(ProcessInfo.hProcess, Result);
     CloseHandle(ProcessInfo.hProcess);
     CloseHandle(ProcessInfo.hThread)
  end
end;

begin
   WinExecAndWait32(S + ' ' + Params, SW_SHOW);
end;

}

end.


