unit Hpmult;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages,
  clipBrd, spin, Registry, math, ComCtrls,
  HPgrapheMult, libusb, ImgList,
  Vcl.StdActns, ActnList,PlatformDefaultStyleActnCtrls,
  ActnMan, CustomizeDlg, ToolWin, ActnCtrls, optionsCSV,
  jmmUtil, AgilentU, FloatEdit, HPdde,
  Vcl.Grids,
  System.Actions,
  system.UITypes, System.ImageList;

type

  TMultimetreForm = class(TForm)
    PanelValeur: TPanel;
    GroupBox3: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox1: TGroupBox;
    GroupBoxFreq: TGroupBox;
    Timer: TTimer;
    LabelFreq: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ImageList1: TImageList;
    PanelReglage: TPanel;
    Panel1: TPanel;
    Oscillo: TPaintBox;
    OscilloBis: TPaintBox;
    GroupBox6: TGroupBox;
    voie1GB: TGroupBox;
    voie2GB: TGroupBox;
    GroupBox9: TGroupBox;
    Label5: TLabel;
    BaseDeTempsLabel: TLabel;
    Offset1Label: TLabel;
    Offset2Label: TLabel;
    Calibre1Label: TLabel;
    Calibre2Label: TLabel;
    TriggerSourceRG: TRadioGroup;
    TriggerSlopeRG: TRadioGroup;
    TriggerModeRG: TRadioGroup;
    LevelLabel: TLabel;
    Edit1: TEdit;
    SpeedButton32: TSpeedButton;
    SpeedButton34: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    posupBtn: TSpeedButton;
    posDnBtn: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    scaleUpBtn: TSpeedButton;
    scaleDnBtn: TSpeedButton;
    Scale2UpBtn: TSpeedButton;
    scale2DnBtn: TSpeedButton;
    levelUpBtn: TSpeedButton;
    levelDnBtn: TSpeedButton;
    Splitter1: TSplitter;
    LabelErreurLecture: TLabel;
    LabelErreur: TLabel;
    ProgressBar: TProgressBar;
    ActionManager1: TActionManager;
    EnregistreAction1: TAction;
    StopAction1: TAction;
    activeAction1: TAction;
    UndoAction: TAction;
    ResetAction1: TAction;
    UnLockAction1: TAction;
    NewPageAction: TAction;
    AddAction: TAction;
    RegressiAction: TAction;
    ToolBar1: TActionToolBar;
    NomEdit: TLabeledEdit;
    UniteEdit: TLabeledEdit;
    ValeurConstEdit: TLabeledEdit;
    CommEdit: TLabeledEdit;
    ExitAction: TAction;
    EditBidon: TEdit;
    FileSaveAction: TFileSaveAs;
    Stat1Btn: TSpeedButton;
    Stat2Btn: TSpeedButton;
    StatPhaseBtn: TSpeedButton;
    Panel2: TPanel;
    StatAction: TAction;
    PaintBoxPhase: TPaintBox;
    PaintBox2: TPaintBox;
    PaintBox1: TPaintBox;
    StringGridPhase: TStringGrid;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    StringGridFreq: TStringGrid;
    PaintBoxFreq: TPaintBox;
    Graphe1Btn: TSpeedButton;
    Graphe2Btn: TSpeedButton;
    GraphePhaseBtn: TSpeedButton;
    LabelDeuxPeriodes: TLabel;
    LabelErreurAcq: TLabel;
    GroupBox4: TGroupBox;
    EditMaxi: TFloatEdit;
    Label4: TLabel;
    EditMini: TFloatEdit;
    Label6: TLabel;
    logCB: TCheckBox;
    Voie1Btn: TRadioButton;
    Voie2Btn: TRadioButton;
    Label7: TLabel;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Memo1: TMemo;
    RazStatBtn: TSpeedButton;
    Raz1: TSpeedButton;
    Raz2: TSpeedButton;
    RazPhase: TSpeedButton;
    PhaseCB: TCheckBox;
    procedure ExitItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreExec(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure UndoExec(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ResetActionExec(Sender: TObject);
    procedure VoieClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EnregistreEditKeyPress(Sender: TObject; var Key: Char);
    procedure TimerTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TriggerSourceRGClick(Sender: TObject);
    procedure TriggerSlopeRGClick(Sender: TObject);
    procedure OscilloBisPaint(Sender: TObject);
    procedure StopActionExecute(Sender: TObject);
    procedure TriggerModeRGClick(Sender: TObject);
    procedure MesureCBClick(Sender: TObject);
    procedure TimeBtnClick(Sender: TObject);
    procedure posupBtnClick(Sender: TObject);
    procedure posDnBtnClick(Sender: TObject);
    procedure scaleUpBtnClick(Sender: TObject);
    procedure scaleDnBtnClick(Sender: TObject);
    procedure levelUpBtnClick(Sender: TObject);
    procedure levelDnBtnClick(Sender: TObject);
    procedure EditMaxiChange(Sender: TObject);
    procedure EditMiniChange(Sender: TObject);
    procedure EditMaxiExit(Sender: TObject);
    procedure EditMiniExit(Sender: TObject);
    procedure logCBClick(Sender: TObject);
    procedure NumVoieRGClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure unlockBtnClick(Sender: TObject);
    procedure AddItemClick(Sender: TObject);
    procedure ExitActionExecute(Sender: TObject);
    procedure EditBidonKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditBidonKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PhaseCBClick(Sender: TObject);
    procedure FileSaveActionAccept(Sender: TObject);
    procedure RegressiActionExecute(Sender: TObject);
    procedure NewPageActionExecute(Sender: TObject);
    procedure Stat2BtnClick(Sender: TObject);
    procedure Graphe1BtnClick(Sender: TObject);
    procedure RazStatBtnClick(Sender: TObject);
  private
    MajEnCours : boolean;
    GrapheMult : TgrapheMult;
    GrapheOsc : TgrapheOsc;
    premierePageOK : boolean;
    AcqASauver : boolean;
    procedure EnvoieDonnees(Ordre : Tenvoi);
    Procedure SetBoutonAcq;
    Procedure SetVoies;
    Procedure EnvoieDemande;
    Procedure Desactive;
  public
  protected
    procedure WMAcqPoint(var Msg: Tmessage); message WM_Acq_Point;
    procedure WMAcqRaz(var Msg: Tmessage);  message WM_Acq_Raz;
  end;

var
  MultimetreForm: TMultimetreForm;

implementation

uses voies, HPmain, statU, statcalc;

{$R *.DFM}

const
     ledIndex : array[boolean] of integer = (12,13);
     captionA : array[boolean] of string = ('Activer','Dsactiver');
     hintA : array[boolean] of string =
        ('Activer la mise  jour en continu',
         'Dsactiver la mise  jour en continu');


procedure TMultimetreForm.ExitActionExecute(Sender: TObject);
begin
  Close
end;

procedure TMultimetreForm.ExitItemClick(Sender: TObject);
begin
    close
end;

procedure TMultimetreForm.FormCreate(Sender: TObject);

Procedure Defaut;
var j : indiceVoieMult;
begin with grapheMult do begin
       for j := voieF to VoieGain do with voies[j] do begin
              Nom := VoieDefaut[j].nom;
              nomUnite := VoieDefaut[j].nomUnite;
              Signif := VoieDefaut[j].signif;
              Command := VoieDefaut[j].command;
              Positive := VoieDefaut[j].positive;
              CalculIncertitude := VoieDefaut[j].CalculIncertitude;
              Mini := VoieDefaut[j].mini;
              Maxi := VoieDefaut[j].maxi;
              NumVoie := VoieDefaut[j].NumVoie;
        end;
        voies[voieGain].active := false;
        voies[voieF].axeLog := true;
        editMini.value := voies[voieF].mini;
        editMaxi.value := voies[voieF].maxi;
        voies[voieF].numVoie := voie1;
        setVoies;
end end;

procedure setGridStat(agrid : TstringGrid);
begin with agrid do begin
    rowCount := 6;
    DefaultRowHeight := font.Size*2+3;
    height := succ(rowCount)*DefaultRowHeight;
    ColWidths[0] := WidthNomStat;
    ColWidths[1] := WidthValeurStat;
    width := WidthGridStat;
    visible := false;
end end;

begin
  GrapheOsc := TgrapheOsc.Create;
  GrapheOsc.paintBox := OscilloBis;
  GrapheMult := TgrapheMult.Create;
  with grapheMult do begin
    paintBox := Oscillo;
    voies[1].LabelVoie := Label1;
    voies[2].LabelVoie := Label2;
    voies[voiePhase].LabelVoie := Label3;
    voies[voieF].LabelVoie := LabelFreq;
    voies[1].GBvoie := GroupBox1;
    voies[2].GBvoie := GroupBox2;
    voies[voiePhase].GBvoie := GroupBox3;
    voies[voieF].GBvoie := GroupBoxFreq;
    voies[1].stat.statPaint := PaintBox1;
    voies[2].stat.statPaint := PaintBox2;
    voies[voiePhase].stat.statPaint := PaintBoxPhase;
    voies[voieF].stat.statPaint := PaintBoxFreq;
    voies[1].stat.statGrid := stringGrid1;
    voies[2].stat.statGrid := stringGrid2;
    voies[voiePhase].stat.statGrid := stringGridPhase;
    voies[voieF].stat.statGrid := stringGridFreq;
  end;
  setGridStat(stringGridFreq);
  setGridStat(stringGrid1);
  setGridStat(stringGridPhase);
  setGridStat(stringGrid2);
  agilent.progressBar := progressBar;
  Defaut;
end;

procedure TMultimetreForm.EnregistreExec(Sender: TObject);
begin
      if ActiveAction1.checked
          then begin
              if not grapheMult.ErreurLectureGlb then
                 grapheMult.EnregistrePointCourant;
              setBoutonAcq;
          end
          else Perform(WM_Acq_Point,1,0)
end;

procedure TMultimetreForm.OscilloPaint(Sender: TObject);
begin
     GrapheMult.DrawG(ActiveAction1.checked);
     labelErreur.top := oscillo.Top+20;
     labelErreurLecture.top := oscillo.Top+50;
     labelDeuxPeriodes.top := oscillo.Top+80;
     labelErreurAcq.top := oscillo.Top+110;
end;

procedure TMultimetreForm.PhaseCBClick(Sender: TObject);
begin
    with grapheMult.voies[voiePhase] do begin
       stat.statGrid.visible := phaseCB.checked and statPhaseBtn.down;
       stat.statPaint.visible := phaseCB.checked and graphePhaseBtn.down;
       statPhaseBtn.Enabled := phaseCB.checked;
       graphePhaseBtn.Enabled := phaseCB.checked;
    end;
    editBidon.SetFocus;
end;

procedure TMultimetreForm.UndoExec(Sender: TObject);
begin // Supprimer dernier point
     Agilent.stop := true;
     with grapheMult do if NbrePoints>0 then dec(NbrePoints);
     Oscillo.refresh;
     setBoutonAcq;
end;

procedure TMultimetreForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
       if stopAction1.enabled then begin
          Agilent.stop := true;
          sleep(1000);
       end;
        if AcqAsauver and
          (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes)
             then FileSaveAction.Execute;
       if unlockAction1.enabled then unLockBtnClick(sender);
       Timer.Enabled := false;
       activeAction1.checked := false;
       AgilentFormMain.setMode(mNone);
//        serieForm.EnvoieCommandeSimple(':KEY:LOCK DIS');
end;

procedure TMultimetreForm.TriggerSourceRGClick(Sender: TObject);
begin
    if majEnCours then exit;
    desactive;
	  case TriggerSourceRG.itemIndex of
         0 : agilent.trigCommand('SOUR CHAN1');
         1 : agilent.trigCommand('SOUR CHAN2');
         2 : agilent.trigCommand('SOUR EXT');
    end;
    Perform(WM_Acq_Raz,0,0);
end;

procedure TMultimetreForm.TriggerModeRGClick(Sender: TObject);
begin
     if majEnCours then exit;
     desactive;
     case TriggerModeRG.itemIndex of
          0 : agilent.trigCommand('SWE AUTO');
          1 : agilent.trigCommand('SWE NORM');
     end;
     levelLabel.visible := TriggerModeRG.itemIndex=1;
     levelUpBtn.visible := TriggerModeRG.itemIndex=1;
     levelDnBtn.visible := TriggerModeRG.itemIndex=1;
     Perform(WM_Acq_Raz,0,0);
end;

procedure TMultimetreForm.TriggerSlopeRGClick(Sender: TObject);
begin
     if majEnCours then exit;
     desactive;
     case TriggerSlopeRG.itemIndex of
          0 : agilent.trigCommand('SLOP POS');
          1 : agilent.trigCommand('SLOP NEG');
     end;
     Perform(WM_Acq_Raz,0,0);
end;

procedure TMultimetreForm.RazStatBtnClick(Sender: TObject);
var voieCourante: Tvoie;
begin
  voieCourante := grapheMult.voies[(sender as TspeedButton).tag];
  with VoieCourante.stat do begin
     reset;
     if StatGrid.Visible then AfficheStat;
     if StatPaint.Visible then DrawStat;
  end;
end;

procedure TMultimetreForm.RegressiActionExecute(Sender: TObject);
begin
     Timer.enabled := false;
     EnvoieDonnees(eLoad);
     setBoutonAcq;
end;

procedure TMultimetreForm.EnvoieDonnees(Ordre : Tenvoi);
var donnees : TstringList;

procedure AjouteConst;
var valeurConst : double;
begin
     if NomEdit.text='' then exit;
     ValeurConst := StrToFloatWin(ValeurConstEdit.text);
     if isNan(valeurConst) then exit;
     donnees.Add('');
     donnees.Add(NomEdit.text);
     donnees.Add(UniteEdit.text);
     donnees.Add(valeurConstEdit.text);
end;

procedure AjouteCodeGraphe;
var j : indiceVoieMult;
    N,i : integer;
begin with grapheMult do begin
      N := voiePhase-voieF;
      if voies[voiePhase].active then inc(N);
      donnees.Add(symbReg2 + intToStr(N)+' NOMX');
      for i := 1 to N do
      donnees.Add('f');
      donnees.Add(symbReg2 + intToStr(N) +' NOMY');
      for j := succ(voieF) to VoiePhase do if voies[j].active then
          donnees.Add(voies[j].nom);
      donnees.Add(symbReg2+intToStr(N)+' COULEUR');
      for j := succ(voieF) to VoiePhase do if voies[j].active then
          donnees.Add(IntToStr(voies[j].color));
      donnees.Add(symbReg2+intToStr(N)+' LIGNE');
      for i := 1 to N do
          donnees.Add('1');
end end;

var i : indiceVecteur;
    j : indiceVoieMult;
    ligne : String;
begin with grapheMult do begin
     Tri;
     Screen.Cursor := crHourGlass;
     donnees := TstringList.create;
     if ordre=eLoad then begin
        donnees.Add(Application.exeName);
        donnees.Add('Diagramme de Bode avec Agilent DSO')
     end;
     donnees.Add(unicodeVersRW3(CommEdit.text));
     Ligne := 'f';
     for j := succ(voieF) to VoiePhase do with voies[j] do if active then
         ligne := ligne + crTab + nom;
     donnees.Add(ligne);
     Ligne := 'Hz';
     for j := succ(voieF) to VoiePhase do with voies[j] do if active then
         ligne := ligne + crTab + nomUnite;
     donnees.Add(ligne);
     Ligne := 'frquence';
     for j := succ(voieF) to VoiePhase do with voies[j] do if active then
         ligne := ligne + crTab + commentaire;
     donnees.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         ligne := FloatToStrPoint(voies[voieF].valeur[i]);
         for j := succ(voieF) to VoiePhase do if active then
            ligne := ligne + crtab + FloatToStrPoint(voies[j].valeur[i]);
         donnees.Add(ligne);
     end;
     donnees.Add(symbReg2+IntToStr(NbrePoints)+' INCERT');
     for i := 0 to pred(NbrePoints) do begin
         ligne :=  FloatToStrPoint(voies[voieF].incertitude[i]);
         for j := succ(voieF) to VoiePhase do if active then
             ligne := ligne + crtab + FloatToStrPoint(voies[j].incertitude[i]);
         donnees.Add(ligne);
     end;
     if ordre in[eLoad,eAdd] then ajouteConst;
     FormDDE.Execute(ordre,donnees,'');
     PremierePageOK := true;
     Donnees.free;
     Screen.Cursor := crDefault;
     AcqASauver := false;
end end; // EnvoieDonnees

procedure TMultimetreForm.SetBoutonAcq;
begin
     EnregistreAction1.enabled := grapheMult.NbrePoints<MaxVecteur;
     UndoAction.enabled := grapheMult.NbrePoints>0;
     ResetAction1.enabled := UndoAction.enabled;
     RegressiAction.enabled := grapheMult.NbrePoints>3;
     FileSaveAction.Enabled := RegressiAction.enabled;
     NewPageAction.Enabled := RegressiAction.enabled and premierePageOK;
     AddAction.Enabled := NewPageAction.enabled;
     timer.enabled := activeAction1.checked;
end;

procedure TMultimetreForm.ResetActionExec(Sender: TObject);
begin
     Agilent.stop := true;
     if OK('Suppression des donnes courantes') then begin
        GrapheMult.NbrePoints := 0;
        Oscillo.refresh;
        setBoutonAcq;
        acqAsauver := false;
//        serieForm.ArretLecture := true;
     end;
end;

procedure TMultimetreForm.scaleDnBtnClick(Sender: TObject);
var numVoie : AnsiString;
    gamme : double;
begin
    numVoie := AnsiString(intTostr((sender as TspeedButton).tag));
    desactive;
    if agilent.usb=oLibUsb
       then agilent.KeyCommand('CH'+numVoie+'_SCALE_DEC')
       else if agilent.infiniVision
       then begin
          gamme := agilent.GetFloat(':CHAN'+numVoie+':SCAL?',1);
          agilent.chanCommand('SCAL '+floatToStrAgilent(valeur125Suivante(gamme,true)),(sender as TspeedButton).tag);
       end
       else agilent.KeyCommand('CH'+numVoie+'_VOLT_DEC');
    Perform(WM_Acq_Raz,0,0)
end;

procedure TMultimetreForm.scaleUpBtnClick(Sender: TObject);
var numVoie : ansiString;
    gamme : double;
begin
    numVoie := ansiString(intTostr((sender as TSpeedButton).tag));
    desactive;
    if agilent.usb=oLibUsb
       then agilent.KeyCommand('CH'+numVoie+'_SCALE_INC')
       else if agilent.infiniVision
       then begin
          gamme := agilent.GetFloat(':CHAN'+numVoie+':SCAL?',1);
          agilent.chanCommand('SCAL '+floatToStrAgilent(valeur125Suivante(gamme,false)),(sender as TspeedButton).tag);
       end
       else agilent.KeyCommand('CH'+numVoie+'_VOLT_INC');
    Perform(WM_Acq_Raz,0,0)
end;

procedure TMultimetreForm.VoieClick(Sender: TObject);
var j : indiceVoieMult;
begin
     Agilent.stop := true;
     timer.enabled := false;
     j := (sender as Tcomponent).tag;
     if voiesDlg=nil then application.createForm(TvoiesDlg,voiesDlg);
     VoiesDlg.voieLue := grapheMult.voies[j];
//      serieForm.ArretLecture := true;
     if VoiesDlg.ShowModal=mrOK then setVoies;
     grapheMult.voies[j].stat.reset;
     Oscillo.invalidate;
     setBoutonAcq;
end;

procedure TMultimetreForm.FileSaveActionAccept(Sender: TObject);
var
   fichier: textFile;
   nomFichier : string;

Procedure sautDeLigne;
begin
    write(Fichier,crLF)
end;

   procedure EcritPage;
   var
      j: integer;
      v: integer;
   begin with grapheMult do
         for j := 0 to pred(NbrePoints) do begin
            Write(fichier, FloatToStr(voies[voieF].valeur[j]));
            for v := succ(voieF) to voiePhase do if voies[v].active then
                Write(fichier, crTab,FloatToStr(voies[v].valeur[j]));
            sautDeLigne;
         end;
   end; // ecritPage

   procedure EcritCSV;
   var
      j: integer;
      v: integer;
   begin with grapheMult do
         for j := 0 to pred(NbrePoints) do begin
            Write(fichier, FloatToStr(voies[voieF].valeur[j]));
            for v := succ(voieF) to voiePhase do if voies[v].active then
                Write(fichier, separeValue,FloatToStr(voies[v].valeur[j]));
            sautDeLigne;
         end;
   end; // ecritPage

   procedure ecritEnTete;
   var
      j: integer;
   begin with grapheMult do begin
         write(fichier, 'Agilent DSOx000');
         sautDeLigne;
         Write(fichier,'f');
         for j := succ(voieF) to VoiePhase do if voies[j].active then
               Write(fichier, crTab, voies[j].nom);
         sautDeLigne;
         Write(fichier, 'Hz');
         for j := succ(voieF) to VoiePhase do if voies[j].active then
               Write(fichier, crTab, voies[j].nomUnite);
         sautDeLigne;
         Write(fichier,'frquence');
         for j := succ(voieF) to VoiePhase do if voies[j].active then
               Write(fichier, crTab, voies[j].signif);
         sautDeLigne;
   end end; // ecritEnTete

var extension : string;
begin
   Screen.Cursor := crHourGlass;
   nomFichier := FileSaveAction.Dialog.FileName;
   extension := AnsiUpperCase(ExtractFileExt(NomFichier));
   if extension='' then extension := '.CSV';
   nomFichier := nomFichier+extension;
   AssignFile(fichier, NomFichier);
   Rewrite(fichier);
   ecritEnTete;
   ecritPage;
   CloseFile(fichier);
   Screen.Cursor := crDefault;
   AcqASauver := false;
end;

procedure TMultimetreForm.FormActivate(Sender: TObject);
(*
var probeStr : ansiString;
    probeFl : double;
    ch : byte;
*)
begin
   setBoutonAcq;
   Perform(WM_Acq_Raz,0,0);
   oscilloBis.visible := agilent.usb=oLibUsb;
   splitter1.visible := oscilloBis.visible;
   agilent.writeString(':BEEP:ENAB OFF');
   case agilent.usb of
      oLibUsb : caption := 'Mesures avec Agilent DSO3000 USB';
      oRigol : caption :=  'Mesures avec Rigol';
      else caption := 'Mesures avec '+ agilent.identificateur;
   end;
   progressBar.Visible := agilent.usb<>oVisaCom;
   memo1.Visible := not agilent.infiniVision;
   Voie1Btn.Checked := true;
   grapheMult.voies[voieF].numVoie := 1;
//   agilent.setRefPhase(voie1);
(*
    try
      for ch := 1 to 2 do begin
          case agilent.usb of
               oHewlett : begin
                  probeStr := serieForm.GetString(':CHAN'+intToStr(ch)+':PROB?');
                  if probeStr<>'X1' then
                     Erreur('Vrifier coeff. de sonde (PROB) '+probeStr+' sur voie'+intToStr(ch));
              end;
              oAgilent : begin
                  probeFl := serieForm.GetFloat(':CHAN'+intToStr(ch)+':PROB?');
                  if round(probeFl)<>1 then
                     Erreur('Vrifier coeff. de sonde (PROB) sur voie'+intToStr(ch));
              end;
          end;
      end;
      except
      end;
*)
end;

Procedure TMultimetreForm.SetVoies;
var j : indiceVoieMult;
    gamme : string;
begin with grapheMult do
    for j := voie1 to voie2 do with voies[j] do begin
           if Positive then gamme := ' +' else gamme := ' ';
           gamme := signif+gamme+strValeur(Maxi);
           GBvoie.Caption := 'CH'+IntToStr(numVoie)+' '+gamme;
           LabelVoie.caption := ' '+nom+' ';
    end;
end; // setVoies

procedure TMultimetreForm.Stat2BtnClick(Sender: TObject);
var voieCourante : Tvoie;
begin
  voieCourante := grapheMult.voies[(sender as TspeedButton).tag];
  with VoieCourante do begin
     stat.statGrid.visible := not stat.StatGrid.visible;
     stat.StatGrid.Top := GBvoie.Top;
     stat.couleurFond := color;
     stat.StatGrid.left := panel1.width-statCalc.WidthGridStat;
     stat.nomUnite := nomUnite;
     stat.AfficheStat;
  end;
end;

procedure TMultimetreForm.levelUpBtnClick(Sender: TObject);
var oldValeur,gamme : double;
    numVoie : ansiString;
begin
   if agilent.usb=oLibUsb
      then agilent.KeyCommand('TRIG_LVL_INC')
      else if agilent.infiniVision
       then begin
          numVoie := AnsiString(intTostr(TriggerSourceRG.itemIndex));
          oldValeur := agilent.GetFloat(':TRIG:LEV?',1);
          gamme := agilent.GetFloat(':CHAN'+numVoie+':SCAL?',1);
          agilent.trigCommand('LEV '+floatToStrAgilent(oldValeur+gamme/10));
        end
       else agilent.KeyCommand('TRIG_LEVEL_INC');
end;

procedure TMultimetreForm.logCBClick(Sender: TObject);
begin
     grapheMult.voies[voieF].axeLog := logCB.checked;
     oscillo.invalidate;
     editBidon.setFocus;
end;

procedure TMultimetreForm.levelDnBtnClick(Sender: TObject);
var numVoie : ansiString;
    oldValeur,gamme : double;
begin
   if agilent.usb=oLibUsb
      then agilent.KeyCommand('TRIG_LVL_DEC')
      else if agilent.infiniVision
      then begin
          numVoie := AnsiString(intTostr(TriggerSourceRG.itemIndex));
          oldValeur := agilent.GetFloat(':TRIG:LEV?',1);
          gamme := agilent.GetFloat(':CHAN'+numVoie+':SCAL?',1);
          agilent.trigCommand('LEV '+floatToStrAgilent(oldValeur-gamme/10));
      end
      else agilent.KeyCommand('TRIG_LEVEL_DEC');
end;

procedure TMultimetreForm.posupBtnClick(Sender: TObject);
var numVoie : AnsiString;
    oldValeur,gamme : double;
begin
     numVoie := AnsiString(intTostr((sender as TspeedButton).tag));
     if agilent.infiniVision
       then begin
          oldValeur := agilent.GetFloat(':CHAN'+numVoie+':OFFS?',1);
          gamme := agilent.GetFloat(':CHAN'+numVoie+':SCAL?',1);
          agilent.chanCommand('OFFS '+floatToStrAgilent(oldValeur-gamme/10),(sender as TspeedButton).tag);
        end
       else agilent.KeyCommand('CH'+numVoie+'_POS_INC');
end;

procedure TMultimetreForm.posDnBtnClick(Sender: TObject);
var numVoie : AnsiString;
    oldValeur : double;
    gamme : double;
begin
    numVoie := ansiString(intTostr((sender as TspeedButton).tag));
    if agilent.infiniVision
       then begin
          oldValeur := agilent.GetFloat(':CHAN'+numVoie+':OFFS?',1);
          gamme := agilent.GetFloat(':CHAN'+numVoie+':SCAL?',1);
          agilent.chanCommand('OFFS '+floatToStrAgilent(oldValeur+gamme/10),(sender as TspeedButton).tag);
       end
       else agilent.KeyCommand('CH'+numVoie+'_POS_DEC');
end;

procedure TMultimetreForm.TimeBtnClick(Sender: TObject);
var position : double;
begin
    desactive;
    if agilent.usb=oLibUsb then
    case (sender as TspeedButton).tag of
         0 : agilent.KeyCommand('TIME_POS_DEC');
         1 : agilent.KeyCommand('TIME_POS_INC');
         2 : agilent.KeyCommand('TIME_SCALE_DEC');
         3 : agilent.KeyCommand('TIME_SCALE_INC');
    end
    else if agilent.infiniVision
       then begin
           position := agilent.GetFloat(':TIM:POS?',1);
           case (sender as TspeedButton).tag of
              0 : agilent.WriteString(':TIM:POS '+floatToStrAgilent(position+baseDeTemps/10));
              1 : agilent.WriteString(':TIM:POS '+floatToStrAgilent(position-baseDeTemps/10));
              2 : agilent.WriteString(':TIM:SCAL '+floatToStrAgilent(valeur125Suivante(baseDeTemps,true)));
              3 : agilent.WriteString(':TIM:SCAL '+floatToStrAgilent(valeur125Suivante(baseDetemps,false)));
           end;
       end
       else
        case (sender as TspeedButton).tag of
           0 : agilent.KeyCommand('TIME_POS_DEC');
           1 : agilent.KeyCommand('TIME_POS_INC');
           2 : agilent.KeyCommand('TIME_DEC');
           3 : agilent.KeyCommand('TIME_INC');
        end;
    Perform(WM_Acq_Raz,0,0);
end;

procedure TMultimetreForm.EnvoieDemande;
var i : indiceVoieMult;
    ModifGamme : boolean;
    exposant,mantisse,coeff : double;
    gammeVoie : string;
    ch : integer;
label fin;
begin
if not agilent.open then exit;
Timer.Enabled := false;
with grapheMult do begin
     try
//     serieForm.arretLecture := false;
//     serieForm.voieSerie.FlushInBuffer;
     agilent.stop := false;
     voies[voiePhase].active := phaseCB.Checked;
     for ch := voieF to voiePhase do
         voies[ch].erreurLecture := false;
     LabelErreurLecture.visible := false;
     LabelErreur.visible := false;
     LabelDeuxPeriodes.visible := false;
     LabelErreurAcq.visible := false;
     if not activeAction1.checked then
          EnregistreAction1.enabled := false;
     Agilent.Flush;
     StopAction1.enabled := true;
     UnLockAction1.Enabled := false;
     if phaseCB.checked and
        (agilent.usb=olibusb) then Agilent.litValeurs(wScreen);
     if agilent.stop then Goto fin;
 //     BaseDeTemps := serieForm.GetFloat(':TIM:RANG?');
     BaseDeTemps := Agilent.GetFloat(':TIM:SCAL?',1e-4);
     for ch := 1 to 2 do begin
         voies[ch].FullScale := Agilent.GetFloat(':CHAN'+AnsiString(intToStr(ch))+':SCAL?',2)*8;
         voies[ch].offset := Agilent.GetFloat(':CHAN'+AnsiString(intToStr(ch))+':OFFS?',1);
  //     FullScale[ch] := serieForm.GetFloat(':CHAN'+intToStr(ch)+':RANG?');
     end;
     Application.ProcessMessages;
     if agilent.stop then Goto fin;
     erreurLectureGlb := false;
     with voies[voieF] do begin
         if not isNan(valeurCourante) then oldValeur := valeurCourante;
         labelVoie.hint := '';
         ValeurCourante := Agilent.GetMeasure(Command,numVoie);
//         ValeurCourante := serieForm.GetFloat(':MEAS:SOUR CHAN'+IntToStr(NumVoie)+';'+Command+'?');
         erreurLecture := isNan(ValeurCourante);
         erreurLectureGlb := erreurLecture;
         if erreurLecture
            then begin
               ValeurCourante := oldValeur;
               LabelVoie.caption := ' '+nom+'=? ';
               labelErreur.caption := 'Pas assez de priodes prsentes  l''cran ?';
               LabelErreur.visible := true;
            end
            else begin
               if valeurCourante>(1/baseDeTemps) then begin // plus de douze priodes
                  labelErreur.caption := 'Trop de priodes prsentes  l''cran !';
                  LabelErreur.visible := true;
               end;
               LabelVoie.caption := ' '+nom+'='+strValeur(valeurCourante)+' ';
               if not isNan(valeurCourante) then begin
                  if not ActiveAction1.checked then oldValeur := valeurCourante;
                  if valeurCourante>maxi then begin
                      maxi := valeur125Sup(valeurCourante);
                      editMaxi.value := maxi;
                      oscillo.Invalidate;
                  end;
                  if valeurCourante<mini then begin
                      mini := valeur125Sup(valeurCourante);
                      editMini.value := mini;
                      oscillo.Invalidate;
                  end;
               end;
            end;
         Application.ProcessMessages;
         if agilent.stop then Goto fin;
     end;
     for i := succ(voieF) to pred(VoiePhase) do with voies[i] do begin
         if not isNan(valeurCourante) then oldValeur := valeurCourante;
         labelVoie.hint := '';
         ValeurCourante := Agilent.GetMeasure(Command,numVoie);
         erreurLecture := isNan(ValeurCourante);
         erreurLectureGlb := erreurLectureGlb or erreurLecture;
         if erreurLecture
            then begin
               ValeurCourante := oldValeur;
               LabelVoie.caption := ' '+nom+'=? ';
               if (nomUnite='Hz') or (nomUnite='s')
                  then begin
                     voies[voieF].erreurLecture := true;
                     LabelDeuxPeriodes.Visible := true;
                     labelVoie.hint := 'Moins de deux priodes ?';
                  end
                  else begin
                     //statusBar.panels[i].Text := 'CH'+intTostr(numvoie)+' sature ?';
                     labelVoie.hint := 'CH'+intTostr(numvoie)+' sature ?';
                  end;
                  break;
            end
            else begin
               LabelVoie.hint := '';
               LabelVoie.caption := ' '+nom+'='+strValeur(valeurCourante)+' ';
               if not activeAction1.checked and
                  not isNan(valeurCourante) then oldValeur := valeurCourante;
            end;
            Application.ProcessMessages;
            if agilent.stop then Goto fin;
     end;
     if phaseCB.checked then with voies[voiePhase] do begin
         if not isNan(valeurCourante) then oldValeur := valeurCourante;
         labelVoie.hint := '';
         ValeurCourante := agilent.phase;
         erreurLecture := isNan(ValeurCourante);
         erreurLectureGlb := erreurLectureGlb or erreurLecture;
         if erreurLecture
            then begin
               ValeurCourante := oldValeur;
               LabelVoie.caption := ' '+nom+'=? ';
               LabelDeuxPeriodes.Visible := true;
               labelVoie.hint := 'Moins de deux priodes ?';
            end
            else begin
               LabelVoie.caption := ' '+nom+'='+strValeur(valeurCourante)+' ';
               if not activeAction1.checked and
                  not isNan(valeurCourante) then oldValeur := valeurCourante;
            end;
            Application.ProcessMessages;
            if agilent.stop then Goto fin;
     end;
     if ErreurLectureGlb
     then begin
         LabelErreurAcq.Visible := true;
         if activeAction1.checked then Oscillo.Refresh;
     end // erreurLectureGlb
     else begin
        frequenceCourante := voies[voieF].valeurCourante;
        for i := voieF to VoiePhase do begin
           if agilent.infiniVision
              then grapheMult.voies[i].setIncertitudeDSOX
              else grapheMult.voies[i].setIncertitude;
           grapheMult.voies[i].labelVoie.update; // cache graphe stat
        end;
        ModifGamme := false;
        for i := succ(voieF) to pred(VoiePhase) do with voies[i] do
            if abs(valeurCourante)>maxi then begin { -512 par ex. }
               exposant := intMaths(log10(abs(valeurCourante))); { 2 }
               coeff := power(10,exposant); { 100 }
               mantisse := int(abs(valeurCourante)/coeff); { 5 }
               maxi := (mantisse+1)*coeff; { 600 }
               if Positive then gammeVoie := ' +' else gammeVoie := ' ';
               gammeVoie := signif+gammeVoie+strValeur(Maxi);
               GBvoie.Caption := 'CH'+intToStr(numVoie)+' '+gammeVoie;
               modifGamme := true;
            end;
        with voies[voieF] do begin
             if abs(valeurCourante)<mini then begin
               mini := valeur125Inf(valeurCourante);
               modifGamme := true;
           end;
           if abs(valeurCourante)>maxi then begin
               maxi := valeur125Sup(valeurCourante);
               modifGamme := true;
           end;
        end;
        if ModifGamme or activeAction1.checked then Oscillo.Invalidate;
     end; // not erreurLectureGlb
     fin : OscilloBis.refresh;
     except
     end;
     setBoutonAcq;
     EnregistreAction1.enabled := true;
     stopAction1.enabled := false;
     LabelErreur.Visible := erreurLectureGlb;
     agilent.unLock;
end end; // EnvoieDemande

procedure TMultimetreForm.EditBidonKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    key := 0;
end;

procedure TMultimetreForm.EditBidonKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    key := 0;
end;

procedure TMultimetreForm.EditMaxiChange(Sender: TObject);
begin
     EditMini.maxValue := EditMaxi.value/10;
     with grapheMult.voies[voieF] do begin
         maxi := EditMaxi.value;
         if mini>maxi/10 then mini := maxi/10;
     end;
     oscillo.invalidate;
end;

procedure TMultimetreForm.EditMaxiExit(Sender: TObject);
var nombre : string;
    posHz : integer;
begin
     nombre := EditMaxi.text;
     posHz := pos('Hz',Nombre);
     if posHz>0 then delete(nombre,posHz,2);
     EditMaxi.value := strToFloatWin(nombre);
     editBidon.SetFocus;
end;

procedure TMultimetreForm.EditMiniChange(Sender: TObject);
begin
     EditMaxi.minValue := EditMini.value*10;
     with grapheMult.voies[voieF] do begin
          mini := EditMini.value;
          if maxi<mini*10 then maxi := mini*10;
     end;
     oscillo.invalidate;
end;

procedure TMultimetreForm.EditMiniExit(Sender: TObject);
var nombre : string;
    posHz : integer;
begin
     nombre := EditMini.text;
     posHz := pos('Hz',Nombre);
     if posHz>0 then delete(nombre,posHz,2);
     EditMini.value := strToFloatWin(nombre);
     editBidon.SetFocus;
end;

procedure TMultimetreForm.EnregistreEditKeyPress(Sender: TObject;var Key: Char);
begin
     if (key=' ') and
         not (activeControl=commEdit) and
         (enregistreAction1.enabled) then begin
         enregistreExec(sender);
         key := #0;
     end;
end;

procedure TMultimetreForm.TimerTimer(Sender: TObject);
begin
    if not stopAction1.enabled then Perform(WM_Acq_Point,0,0)
end;

procedure TMultimetreForm.unlockBtnClick(Sender: TObject);
begin
    agilent.unLock
end;

procedure TMultimetreForm.FormDestroy(Sender: TObject);
begin
     GrapheMult.Free;
     GrapheOsc.free;
     MultimetreForm := nil;
end;

procedure TMultimetreForm.FormResize(Sender: TObject);
var i : integer;
    hauteur : integer;
begin
	oscilloBis.Height := 2*Panel1.Height div 5;
  hauteur := Panel1.height div 4;
  for i :=  voieF to voiePhase  do with grapheMult.voies[i] do begin
      GBvoie.Height := hauteur;
      stat.StatGrid.Top := GBvoie.Top;
      stat.StatGrid.left := panel1.width-statCalc.WidthGridStat;
      stat.StatPaint.Height := hauteur-stat.StatPaint.top;
  end;
end;

procedure TMultimetreForm.Graphe1BtnClick(Sender: TObject);
var voieCourante : Tvoie;
begin
  voieCourante := grapheMult.voies[(sender as TspeedButton).tag];
  with VoieCourante do begin
     stat.statPaint.visible := not stat.StatPaint.visible;
     stat.couleurFond := color;
     stat.nom := nom;
     if stat.StatPaint.Visible then stat.DrawStat;
  end;
end;

procedure TMultimetreForm.StopActionExecute(Sender: TObject);
begin
     Agilent.stop := true;
     activeAction1.checked := false;
     activeAction1.imageIndex := ledIndex[false];
     activeAction1.caption := captionA[false];
     activeAction1.hint := hintA[false];
     timer.enabled := false;
     StopAction1.enabled := false;
     UnLockAction1.enabled := true;
//      serieForm.ArretLecture := true;
//     serieForm.EnvoieCommandeRapide('*RST');
end;

procedure TMultimetreForm.FormDeactivate(Sender: TObject);
begin
   Timer.enabled := false;
   activeAction1.checked := false;
   activeAction1.imageIndex := ledIndex[false];
   activeAction1.caption := captionA[false];
   activeAction1.hint := hintA[false];
end;

procedure TMultimetreForm.OscilloBisPaint(Sender: TObject);
begin
     GrapheOsc.DrawG
end;

procedure TMultimetreForm.MesureCBClick(Sender: TObject);
begin
    	timer.enabled := activeAction1.checked;
      activeAction1.imageIndex := ledIndex[activeAction1.checked];
      activeAction1.caption := captionA[activeAction1.checked];
      activeAction1.hint := hintA[activeAction1.checked];
end;

procedure TMultimetreForm.NewPageActionExecute(Sender: TObject);
begin
     Timer.enabled := false;
     EnvoieDonnees(eAdd);
     setBoutonAcq;
end;

procedure TMultimetreForm.NumVoieRGClick(Sender: TObject);
begin
     grapheMult.voies[voieF].numVoie := (sender as TradioButton).tag;
//     agilent.setRefPhase((sender as TradioButton).tag);
     editBidon.SetFocus;
end;

procedure TMultimetreForm.WMAcqPoint(var Msg: Tmessage);
begin
   	envoieDemande;
    if (msg.WParam=1) and not grapheMult.ErreurLectureGlb then
       grapheMult.EnregistrePointCourant;
    acqASauver := grapheMult.NbrePoints>3;
end;

procedure TMultimetreForm.WMAcqRaz(var Msg: Tmessage);
var reponse : string;
    zz : double;
label fin;
begin
    if isNan(baseDeTemps) then baseDeTemps := 0.01;
    if baseDeTemps<0.05
       then sleep(round(baseDeTemps*30000)+100)
       else sleep(1500);

    stopAction1.enabled := true;
    unLockAction1.enabled := false;
    if phaseCB.checked and
       (agilent.usb=olibusb) then Agilent.litValeurs(wScreen);
    if agilent.stop then goto fin;

    oscilloBis.refresh;

    MajEnCours := true;

    BaseDeTemps := agilent.getFloat(':TIM:SCAL?',1e-4);

    BaseDeTempsLabel.caption := ' '+formatCourt(BaseDeTemps,'s/div ');

    zz := agilent.getFloat(':CHAN1:SCAL?',2);
    Calibre1Label.caption := ' '+formatCourt(zz,'V/div ');
    scaleDnBtn.Enabled := zz<5;
    scaleUpBtn.Enabled := zz>0.0021;
    grapheMult.voies[voie1].fullscale := zz*8;
    zz := agilent.GetFloat(':CHAN1:OFFS?',0);
    grapheMult.voies[voie1].offset := zz;
    Offset1Label.caption := ' '+formatCourt(zz,'V ');
    grapheMult.voies[voie1].incertitudeType := (0.0425*grapheMult.voies[voie1].fullscale+
           0.01*grapheMult.voies[voie1].offset)/sqrt(3);

    zz := agilent.getFloat(':CHAN2:SCAL?',2);
    Calibre2Label.caption := ' '+formatCourt(zz,'V/div ');
    scale2DnBtn.Enabled := zz<5;
    scale2UpBtn.Enabled := zz>0.0021;
    grapheMult.voies[voie2].fullscale := zz*8;
    zz := agilent.GetFloat(':CHAN2:OFFS?',0);
    grapheMult.voies[voie2].offset := zz;
    Offset2Label.caption := ' '+formatCourt(zz,'V ');
    grapheMult.voies[voie2].incertitudeType := (0.0425*grapheMult.voies[voie2].fullscale+
           0.01*grapheMult.voies[voie2].offset)/sqrt(3);

    if agilent.usb=olibusb
       then reponse := string(agilent.getString(':TRIG:SOUR?'))
       else reponse := string(agilent.getString(':TRIG:EDGE:SOUR?'));
    if pos('1',reponse)>0 then triggerSourceRG.itemIndex := 0;
    if pos('2',reponse)>0 then triggerSourceRG.itemIndex := 1;
    if pos('EXT',reponse)>0 then triggerSourceRG.itemIndex := 2;

    if agilent.usb=olibusb
       then reponse := string(agilent.getString(':TRIG:SLOP?'))
       else reponse := string(agilent.getString(':TRIG:EDGE:SLOP?'));
    if pos('NEG',reponse)>0 then triggerSlopeRG.itemIndex := 1;
    if pos('POS',reponse)>0 then triggerSlopeRG.itemIndex := 0;

    MajEnCours := false;

    fin:
    panelReglage.enabled := true;
    toolBar1.enabled := true;
    stopAction1.enabled := false;
    enregistreAction1.enabled := true;
    agilent.unLock;
    editBidon.SetFocus;
end;

procedure TMultimetreForm.AddItemClick(Sender: TObject);
begin
     Timer.enabled := false;
     EnvoieDonnees(ePlus);
     setBoutonAcq;
end;

procedure TMultimetreForm.desactive;
begin
    panelReglage.enabled := false;
    toolBar1.enabled := false;
    stopAction1.enabled := true;
    unLockAction1.enabled := false;
end;

end.


