unit Jmmutil;

interface

uses
   SysUtils, Windows, Messages, Classes, Dialogs, Forms,
   StdCtrls, Consts, ShlObj, Math, system.UITypes;

const
   SymbReg: char = '';
   SymbReg2: char = '&';
   Tabulation = #9;

type
   ChaineAzt = array[0..255] of char;
   CoeffUnite = (zero, yocto, zepto, atto, femto, pico, nano, micro, milli,
      nulle, kilo, mega, giga, tera, peta, exa, zetta, yotta, infini);
   TIncertitudeComposee = (iConstructeur, icMoyenne, icSigma);

const
        alphaR =  AnsiChar(128);
        betaR = AnsiChar(129);
        chiR = AnsiChar(130);
        deltaR = AnsiChar(131); deltaMajR = AnsiChar(150);
        epsilonR = AnsiChar(132);
        phiR = AnsiChar(133); phiMajR = AnsiChar(151);
        gammaR = AnsiChar(134); gammaMajR = AnsiChar(152);
        etaR = AnsiChar(135);
        lambdaR = AnsiChar(136); lambdaMajR = AnsiChar(153);
        nuR = AnsiChar(138);
        piR = AnsiChar(139);piMajR = AnsiChar(154);
        thetaR = AnsiChar(140);thetaMajR = AnsiChar(155);
        rhoR = AnsiChar(141);
        sigmaR = AnsiChar(142);sigmaMajR = AnsiChar(156);
        tauR = AnsiChar(143);
        omegaR = AnsiChar(144);omegaMajR = AnsiChar(157);
        xiR = AnsiChar(147);xiMajR = AnsiChar(158);
        psiR = AnsiChar(148);psiMajR = AnsiChar(159);
        zetaR = AnsiChar(149);
        muR = AnsiChar(181);

        alpha=WideChar($03B1);alphaMaj=WideChar($0391);
        beta=WideChar($03B2);betaMaj=WideChar($0392);
        gamma=WideChar($03B3);gammaMaj=WideChar($0393);
        delta=WideChar($03B4);deltaMaj = WideChar($0394);
        chi=WideChar($03C7);chiMaj=WideChar($03A7);
        epsilon=WideChar($03B5);epsilonMaj=WideChar($0395);
        upsilon=WideChar($03C5);upsilonMaj=WideChar($03A5);
        iota=WideChar($03B9);iotaMaj=WideChar($0399);
        phi=WideChar($03C6);phiMaj=WideChar($03A6);
        eta=WideChar($03B7);etaMaj=WideChar($0397);
        lambdaMaj=WideChar($039B);lambda=WideChar($03BB);
        nu=WideChar($03BD);nuMaj=WideChar($039D);
        xiMaj=WideChar($039E);xi=WideChar($03BE);
        piMin=WideChar($03C0);piMaj=WideChar($03A0);
        thetaMaj=WideChar($0398);theta=WideChar($03B8);
        rho=WideChar($03C1);rhomaj=WideChar($03A1);
        sigmaMin=WideChar($03C3);sigmaMaj=WideChar($03A3);
        tau=WideChar($03C4); tauMaj=WideChar($03A4);
        omega=WideChar($03C9);omegaMaj=WideChar($03A9);
        psi=WideChar($03C8);psiMaj=WideChar($03A8);
        zeta=WideChar($03B6);zetaMaj=WideChar($0396);
        mu=WideChar($03BC);muMaj=WideChar($039C);
        kappa=WideChar($03BA);kappaMaj=WideChar($039A);
        omicron=WideChar($03Bf);omicronMaj=WideChar($039F);
        vide=WideChar(2205);videMaj=WideChar(2205);
        supegal=WideChar(2265);
        infegal=WideChar(2264);

        Grecque = alpha+beta+gamma+gammaMaj+delta+deltaMaj+epsilon+
              chi+zeta+eta+theta+thetaMaj+kappa+
              lambda+lambdaMaj+mu+nu+xi+xiMaj+
              piMin+piMaj+rho+sigmaMin+sigmaMaj+tau+
              phi+phiMaj+chi+psi+psiMaj+omega+omegaMaj;

   Chiffre = ['0'..'9'];
   ChiffreEtc = ['0'..'9', '+', '-', 'e', 'E', '.'];
   ChiffreWin = ['0'..'9', '+', '-', 'e', 'E', '.', ','];
   crTab      = char(vk_tab);
   crSupprArr = char(vk_back);
   crHaut     = char(vk_up);
   crBas      = char(vk_down);
   crGauche   = char(vk_left);
   crDroite   = char(vk_right);
   crHome     = char(vk_home);
   crEnd      = char(vk_end);
   crCR       = #13;   // $0D
   crLF       = #10;   // $0A
   crESC      = #27;
   crXon      = #17;
   crXoff     = #19;
   symboleUnite: array[coeffUnite] of Char =
      ('0', 'y', 'z', 'a', 'f', 'p', 'n', '', 'm', ' ', 'k', 'M', 'G',
      'T', 'P', 'E', 'Z', 'Y', '');
   valUnite: array[coeffUnite] of real =
      (1E-27, 1E-24, 1E-21, 1E-18, 1E-15, 1E-12, 1E-9, 1E-6, 1E-3, 1,
      1E+3, 1E+6, 1E+9, 1E+12, 1E+15, 1E+18, 1E+21, 1E+24, 1E+27);
   caracUnite =
      ['A'..'Z', 'a'..'z', '1'..'3', '-', '.', '/', ''];
   puissanceUnite: array[coeffUnite] of shortint =
      (-27, -24, -21, -18, -15, -12, -9, -6, -3,
      0, +3, +6, +9, +12, +15, +18, +21, +24, +27);
   expUnite: array[coeffUnite] of string =
      ('E-27', 'E-24', 'E-21', 'E-18', 'E-15', 'E-12', 'E-9', 'E-6', 'E-3',
      '', 'E+3', 'E+6', 'E+9', 'E+12', 'E+15', 'E+18', 'E+21', 'E+24', 'E+27');
   separateur = [' ', crTab, ','];
   caracPrefixe =
      ['y', 'z', 'a', 'f', 'p', 'n', '', 'm', 'k', 'M', 'G', 'T', 'P', 'E'];

function FormatCourt(nombre: double; NomUnite: String): String;
function FloatToStrPoint(valeur: double): String;
function FloatToStrAff(valeur: double): String;
function FloatToStrAgilent(valeur: double): AnsiString;
function StrToFloatWin(nombre: String): double;
function StrToFloatPoint(nombre: String): double;
function IntMaths(x: double): double;
function OK(texte: string): boolean;
procedure Erreur(texte: string);
function valeur125(valeur: double): double;
function valeur125Sup(valeur: double): double;
function valeur125Inf(valeur: double): double;
function valeur125Suivante(valeur: double;up : boolean): double;
Function UnicodeVersRW3(s : string) : string;
function ChanScaleEff(veff : double) : double;
function ChanScaleCalibre(calibre : double) : double;
function TimeScale(freq : double) : double;
function intToAStr(i : integer) : ansiString;

var
   appDataDir, MesDocsDir: string;
   separeValue : char = ',';
   IncertitudeComposee : TincertitudeComposee = iConstructeur;

implementation

function intToAStr(i : integer) : ansiString;
begin
   result := ansiString(intToStr(i))
end;

procedure ConvertitPrefixe(var nombre: String);
var
   u: coeffUnite;
   c: Char;
   i: integer;
begin
   i := 1;
   while i <= length(nombre) do begin
      if nombre[i] = ' ' then
         Delete(nombre, i, 1)
      else
         Inc(i);
   end;
   c := nombre[length(nombre)];
   if charInSet(c,caracPrefixe) then begin
      u := zero;
      repeat
         Inc(u)
      until (c = symboleUnite[u]);
      Delete(nombre, length(nombre), 1);
      nombre := nombre + expUnite[u];
   end;
end;

function FloatToStrPoint(valeur: double): String;
var
   nombre: string;
   posSeparator: integer;
begin
   nombre := FloatToStrF(valeur, ffGeneral, 7, 1);
   if formatSettings.decimalSeparator <> '.' then begin
      posSeparator := pos(formatSettings.decimalSeparator, nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := '.';
   end;
   Result := nombre;
end;

function FloatToStrAff(valeur: double): String;
begin
   result := FloatToStrF(valeur, ffGeneral, 4, 1);
end;

function FloatToStrAgilent(valeur: double): AnsiString;
var
   nombre: string;
   posE: integer;
begin
   nombre := FloatToStrF(valeur, ffExponent, 4, 1);
   if formatSettings.decimalSeparator <> '.' then begin
      posE := pos(formatSettings.decimalSeparator, nombre);
      if posE > 0 then
         Nombre[posE] := '.';
   end;
   posE := pos('E+0',nombre);
   if posE>2 then nombre := copy(nombre,1,posE-1);
   Result := ansiString(nombre);
end;

function FormatCourt(Nombre: double; NomUnite: string): string;
var
   unite:  coeffUnite;
   Negatif: boolean;
   tampon: string;
begin
   if isnan(nombre) then
      FormatCourt := ' '
   else begin
      negatif := nombre < 0;
      nombre := abs(nombre);
      unite := nulle;
      while (nombre >= 999) and (unite < infini) do begin
         nombre := nombre / 1000;
         Inc(unite);
      end; { nombre<1000 ou infini }
      while (nombre < 0.999) and (unite > zero) do begin
         nombre := nombre * 1000;
         Dec(unite);
      end; { nombre>=1 ou zero }
      if unite in [infini, zero] then
         tampon := '0 '
      else begin
         tampon := FloatToStrF(nombre, ffGeneral, 4, 0);
         if negatif then
            tampon := '-' + tampon;
         tampon := tampon + ' ';
         if unite <> nulle then
            tampon := tampon + symboleUnite[unite];
      end;
      FormatCourt := tampon + NomUnite;
   end;
end;

function IntMaths(x: double): double;
// "vraie" partie entire
var
   zut: double;
begin
   Zut := int(x);
   if (x >= 0) or (zut = x)
      then intMaths := zut
      else intMaths := zut - 1;
end;

function OK(texte: string): boolean;
begin
   OK := MessageDlg(texte, mtConfirmation, [mbYes, mbNo], 0) = idYes;
end;

function ChanScaleEff(veff : double) : double;
var exposant,coeff : double;
    mantisse : double;
begin
    Veff := Veff*sqrt(2)/4; // 4 = 8 carreaux centrs ; sqrt(2) :  valeur efficace
    exposant := intMaths(log10(Veff)); { 2 }
    coeff := power(10,exposant); { 100 }
    mantisse := int(Veff/coeff); { 5 }
    if mantisse=1
       then mantisse := 2
       else if mantisse<5
            then mantisse := 5
            else mantisse := 10;
    result := mantisse*coeff
end;

function ChanScaleCalibre(calibre : double) : double;
var exposant,coeff : double;
    mantisse : double;
begin
    exposant := intMaths(log10(calibre)); { 2 }
    coeff := power(10,exposant); { 100 }
    mantisse := int(calibre/coeff); { 5 }
    if mantisse=1
       then mantisse := 2
       else if mantisse<5
            then mantisse := 5
            else mantisse := 10;
    result := mantisse*coeff
end;

function TimeScale(freq : double) : double;
var exposant,coeff : double;
    mantisse : double;
begin
    freq := 2/freq/10;  // 2 priodes sur 10 carreaux ; exemple 512
    exposant := intMaths(log10(freq)); { 2 }
    coeff := power(10,exposant); { 100 }
    mantisse := int(freq/coeff); { 5 }
    if mantisse=1
       then mantisse := 2
       else if mantisse<5
            then mantisse := 5
            else mantisse := 10;
    result := mantisse*coeff;
end;


procedure Erreur(texte: string);
begin
   MessageDlg(texte, mtInformation, [mbOK], 0);
end;

function valeur125(valeur: double): double;
var
   mantisse, exposant, coeff: double;
begin
   exposant := log10(valeur);
   coeff := Int(exposant);
   if (exposant < 0) and
      (coeff <> exposant) then
         coeff := coeff - 1;
   coeff := power(10,coeff);
   mantisse := Int(valeur / coeff);
   if mantisse > 2 then
      if mantisse < 6
         then mantisse := 5
         else mantisse := 10;
   Result := mantisse * coeff;
end;

function valeur125Sup(valeur: double): double;
var
   mantisse, exposant, coeff: double;
begin
   exposant := log10(valeur);
   coeff := Int(exposant);
   if (exposant < 0) and (coeff <> exposant) then
      coeff := coeff - 1;
   coeff := power(10,coeff);
   mantisse := ceil(valeur / coeff);
   if mantisse > 2 then
      if mantisse < 6
         then mantisse := 5
         else mantisse := 10;
   Result := mantisse * coeff;
end;

function valeur125Inf(valeur: double): double;
var
   mantisse, exposant, coeff: double;
begin
   exposant := log10(valeur);
   coeff := Int(exposant);
   if (exposant < 0) and (coeff <> exposant) then
      coeff := coeff - 1;
   coeff := power(10,coeff);
   mantisse := floor(valeur / coeff);
   if mantisse > 1 then
      if mantisse < 5
         then mantisse := 2
         else mantisse := 5;
   Result := mantisse * coeff;
end;

function valeur125Suivante(valeur: double;up : boolean): double;
begin
   if up
      then result := valeur125(valeur*2)
      else result := valeur125(valeur/2)
end;

function AddBackSlash(aPath: string): string;
begin
   Result := EmptyStr;
   if (aPath <> '') and (aPath[Length(aPath)] <> '\') then
      Result := aPath + '\';
end;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
function GetFolder(CSIDLValue: integer): string;
var
   IdList: PITEMIDLIST;
   Folder: array[0..MAX_PATH] of char;
begin
   if not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then
   begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
   end;
end;

function StrToFloatWin(nombre: string): double;
var
   posSeparator: byte;
begin
   case formatSettings.decimalSeparator of
        '.' : posSeparator := pos(',', nombre);
        ',' : posSeparator := pos('.', nombre);
        else posSeparator := 0;
   end;
   if posSeparator > 0 then
      Nombre[posSeparator] := formatSettings.decimalSeparator;
   convertitPrefixe(nombre);
   try
      result := strToFloat(nombre);
   except
      result := math.Nan
   end;
end;

function StrToFloatPoint(nombre: string): double;
var
   posSeparator: byte;
begin
   if formatSettings.decimalSeparator<>'.' then begin
       posSeparator := pos('.', nombre);
       if posSeparator > 0 then
          Nombre[posSeparator] := formatSettings.decimalSeparator;
   end;
   try
      result := strToFloat(nombre);
   except
      result := math.Nan
   end;
end;


Function UnicodeVersRW3(s : string) : string;
var i : integer;
    carac : char;
    caracR : AnsiChar;
begin
     result := '';
     for i := 1 to length(s) do begin
         carac := s[i];
         if pos(carac,grecque)>0
            then case carac of
                      alpha : caracR := alphaR;
                      beta : caracR := betaR;
                      gamma: caracR := gammaR;
                      gammaMaj: caracR := gammaMajR;
                      delta: caracR := deltaR;
                      deltaMaj: caracR := deltaMajR;
                      epsilon: caracR := epsilonR;
                      zeta: caracR := zetaR;
                      eta: caracR := etaR;
                      kappa: caracR := 'k';
                      lambda: caracR := lambdaR;
                      lambdaMaj: caracR := lambdaMajR;
                      mu: caracR := '';
                      nu: caracR := nuR;
                      xi: caracR := xiR;
                      xiMaj: caracR := xiMajR;
                      pimin: caracR := piR;
                      piMaj: caracR := piMajR;
                      rho: caracR := rhoR;
                      sigmaMin: caracR := sigmaR;
                      sigmaMaj: caracR := sigmaMajR;
                      tau: caracR := tauR;
                      theta: caracR := thetaR;
                      thetaMaj: caracR := thetaMajR;
                      phi: caracR := phiR;
                      phiMaj: caracR := phiMajR;
                      chi: caracR := chiR;
                      psi: caracR := psiR;
                      psiMaj: caracR := psiMajR;
                      omega: caracR := omegaR;
                      omegaMaj: caracR := omegaMajR;
                      else caracR := '?';
                 end
            else caracR := AnsiChar(carac);
            result := result+caracR;
     end;
end;

initialization
   mesDocsDir := GetFolder(CSIDL_Personal) + 'Regressi';
   if not DirectoryExists(MesDocsDir) then
      createDir(MesDocsDir);
   MesDocsDir := AddBackSlash(mesDocsDir);
   appDataDir := GetFolder(CSIDL_AppData) + 'Regressi';
   if not DirectoryExists(appDataDir) then
       createDir(appDataDir);
   appDataDir := AddBackSlash(appDataDir);
end.

