unit OneInst;

interface

uses
  Windows, Forms, SysUtils, Messages, clipbrd;

const
     WM_File_Load = WM_USER + 2;
     WM_Focus = WM_USER + 1;
     NomProg = 'AgilentDSO';
     TitreFenetre = 'Acquisition';

implementation

procedure EnsureSingleInstance;
var
  Wnd: HWnd;
  WndText: array[0..255] of char;
begin
  if (CreateMutex(nil,false,strPcopy(WndText,NomProg))<>0) and
     (getLastError=ERROR_ALREADY_EXISTS) then begin
    Wnd := GetWindow(Application.Handle, gw_HWndFirst);
    while Wnd <> 0 do begin
      { Look for the other TApplication window out there }
      if Wnd <> Application.Handle then begin
        { Check it's definitely got the same class and caption }
        GetWindowText(Wnd, WndText, Succ(Length(TitreFenetre)));
        if (StrPas(WndText) = TitreFenetre) then begin
          { This technique is used by the VCL: post }
          { a message then bring the window to the }
          { top, before the message gets processed }
          PostMessage(Wnd, wm_SysCommand, sc_Restore, 0);
          SetForegroundWindow(Wnd);
          PostMessage(Wnd,wm_focus,1,0);
          Halt
        end
      end;
      Wnd := GetWindow(Wnd, gw_HWndNext)
    end
  end
end;

initialization
  EnsureSingleInstance
end.
