unit OptionsCSV;

interface

uses
  Winapi.Windows, Winapi.Messages, registry,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, jmmUtil;

type
  TOptionsCSVForm = class(TForm)
    SepareRG: TRadioGroup;
    DataCB: TCheckBox;
    BitBtn1: TBitBtn;
    IncertCB: TComboBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure Maj;
  public
    dataOnly : boolean;
  end;

var
  OptionsCSVForm: TOptionsCSVForm;

implementation

{$R *.dfm}

procedure TOptionsCSVForm.BitBtn1Click(Sender: TObject);
var Ini : TregInifile;
begin
    Ini := TregIniFile.create('Software\Agilent');
    Ini.WriteInteger('CSV','Separe',SepareRG.itemIndex);
    Ini.WriteBool('CSV','Data',DataCB.checked);
    Ini.WriteInteger('Stat','Composee',ord(incertitudeComposee));
    Ini.Free;
    Maj;
end;

procedure TOptionsCSVForm.Maj;
begin
    dataOnly := dataCB.checked;
    incertitudeComposee := TIncertitudeComposee(incertCB.itemIndex);
    case separeRG.itemIndex of
         1 : begin
             jmmUtil.separeValue := ',';
             formatSettings.DecimalSeparator := '.';
         end;
         2 : begin
             jmmUtil.separeValue := ';';
             formatSettings.DecimalSeparator := ',';
         end;
    end;
end;

procedure TOptionsCSVForm.FormCreate(Sender: TObject);
var Ini : TregInifile;
begin
    Ini := TregIniFile.create('Software\AgilentReg');
    separeRG.itemIndex := Ini.ReadInteger('CSV','Separe',0);
    dataCB.checked := Ini.ReadBool('CSV','Data',true);
    incertCB.ItemIndex := Ini.ReadInteger('Stat','Composee',0);
    Ini.Free;
    Maj;
end;

end.
